diff -Naur WebKit-r41128/WebCore/platform/text/gtk/TextCodecGtk.h WebKit-r41128-nx/WebCore/platform/text/gtk/TextCodecGtk.h
--- WebKit-r41128/WebCore/platform/text/gtk/TextCodecGtk.h	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/text/gtk/TextCodecGtk.h	2009-02-23 16:01:27.196007190 -0500
@@ -0,0 +1,149 @@
+/*
+ * Copyright (C) 2004, 2006, 2007 Apple Inc. All rights reserved.
+ * Copyright (C) 2006 Alexey Proskuryakov <ap@nypop.com>
+ * Copyright (C) 2008 Jürg Billeter <j@bitron.ch>
+ * Copyright (C) 2008 Dominik Röttsches <dominik.roettsches@access-company.com>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
+ * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
+ * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */
+
+#ifndef TextCodecGTK_h
+#define TextCodecGTK_h
+
+#include <glib.h>
+
+#include "TextCodec.h"
+#include "TextEncoding.h"
+
+namespace WebCore {
+
+    class TextCodecGtk : public TextCodec {
+    public:
+        static void registerBaseEncodingNames(EncodingNameRegistrar);
+        static void registerBaseCodecs(TextCodecRegistrar);
+
+        static void registerExtendedEncodingNames(EncodingNameRegistrar);
+        static void registerExtendedCodecs(TextCodecRegistrar);
+
+        TextCodecGtk(const TextEncoding&);
+        virtual ~TextCodecGtk();
+
+        virtual String decode(const char*, size_t length, bool flush, bool stopOnError, bool& sawError);
+        virtual CString encode(const UChar*, size_t length, UnencodableHandling);
+
+    private:
+        void createIConvDecoder() const;
+        void createIConvEncoder() const;
+        void releaseIConv() const;
+
+        static void registerEncodingNames(EncodingNameRegistrar registrar, bool extended);        
+        static void registerCodecs(TextCodecRegistrar registrar, bool extended);
+        static gboolean isEncodingAvailable(const gchar*);
+
+        TextEncoding m_encoding;
+        size_t m_numBufferedBytes;
+        unsigned char m_bufferedBytes[16]; // bigger than any single multi-byte character        
+        mutable GIConv m_iconvDecoder;
+        mutable GIConv m_iconvEncoder;
+
+        static const gchar* m_internalEncodingName;
+
+        typedef const gchar* const codecAliasList[];
+
+        // Unicode
+        static codecAliasList m_codecAliases_UTF_8;
+
+        // Western
+        static codecAliasList m_codecAliases_ISO_8859_1;
+        static codecAliasList m_codecAliases_MACROMAN;
+
+        // Japanese
+        static codecAliasList m_codecAliases_SHIFT_JIS;
+        static codecAliasList m_codecAliases_EUC_JP;
+        static codecAliasList m_codecAliases_ISO_2022_JP;
+
+        // Traditional Chinese
+        static codecAliasList m_codecAliases_BIG5;
+        static codecAliasList m_codecAliases_BIG5_HKSCS;
+        static codecAliasList m_codecAliases_CP950;
+
+        // Korean
+        static codecAliasList m_codecAliases_ISO_2022_KR;
+        static codecAliasList m_codecAliases_CP949;
+        static codecAliasList m_codecAliases_EUC_KR;
+
+        // Arabic
+        static codecAliasList m_codecAliases_ISO_8859_6;
+        static codecAliasList m_codecAliases_CP1256;
+
+        // Hebrew
+        static codecAliasList m_codecAliases_ISO_8859_8;
+        static codecAliasList m_codecAliases_CP1255;
+
+        // Greek
+        static codecAliasList m_codecAliases_ISO_8859_7;
+        static codecAliasList m_codecAliases_CP869;
+        static codecAliasList m_codecAliases_WINDOWS_1253;
+
+        // Cyrillic
+        static codecAliasList m_codecAliases_ISO_8859_5;
+        static codecAliasList m_codecAliases_KOI8_R;
+        static codecAliasList m_codecAliases_CP866;
+        static codecAliasList m_codecAliases_KOI8_U;
+        static codecAliasList m_codecAliases_WINDOWS_1251;
+        static codecAliasList m_codecAliases_MACCYRILLIC;
+
+        // Thai
+        static codecAliasList m_codecAliases_CP874;
+        static codecAliasList m_codecAliases_TIS_620;
+
+        // Simplified Chinese
+        static codecAliasList m_codecAliases_GBK;
+        static codecAliasList m_codecAliases_HZ;
+        static codecAliasList m_codecAliases_GB18030;
+        static codecAliasList m_codecAliases_EUC_CN;
+        static codecAliasList m_codecAliases_2312_80; 
+
+        // Central European
+        static codecAliasList m_codecAliases_ISO_8859_2;
+        static codecAliasList m_codecAliases_CP1250;
+        static codecAliasList m_codecAliases_MACCENTRALEUROPE;
+
+        // Vietnamese
+        static codecAliasList m_codecAliases_CP1258;
+
+        // Turkish
+        static codecAliasList m_codecAliases_CP1254;
+        static codecAliasList m_codecAliases_ISO_8859_9;
+
+        // Baltic
+        static codecAliasList m_codecAliases_CP1257;
+        static codecAliasList m_codecAliases_ISO_8859_4;
+
+        static gconstpointer const m_iconvBaseCodecList[];
+        static gconstpointer const m_iconvExtendedCodecList[];
+
+    };
+
+} // namespace WebCore
+
+#endif // TextCodecGTK_h
diff -Naur WebKit-r41128/WebCore/platform/text/TextBreakIterator.h WebKit-r41128-nx/WebCore/platform/text/TextBreakIterator.h
--- WebKit-r41128/WebCore/platform/text/TextBreakIterator.h	2008-12-24 23:47:41.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/text/TextBreakIterator.h	2009-02-23 16:01:27.220006110 -0500
@@ -35,7 +35,9 @@
     TextBreakIterator* sentenceBreakIterator(const UChar*, int length);
 
     int textBreakFirst(TextBreakIterator*);
+    int textBreakLast(TextBreakIterator*);
     int textBreakNext(TextBreakIterator*);
+    int textBreakPrevious(TextBreakIterator*);
     int textBreakCurrent(TextBreakIterator*);
     int textBreakPreceding(TextBreakIterator*, int);
     int textBreakFollowing(TextBreakIterator*, int);
diff -Naur WebKit-r41128/WebCore/platform/text/TextBreakIteratorICU.cpp WebKit-r41128-nx/WebCore/platform/text/TextBreakIteratorICU.cpp
--- WebKit-r41128/WebCore/platform/text/TextBreakIteratorICU.cpp	2009-01-21 00:14:22.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/text/TextBreakIteratorICU.cpp	2009-02-23 16:01:27.244006670 -0500
@@ -89,11 +89,21 @@
     return ubrk_first(bi);
 }
 
+int textBreakLast(TextBreakIterator* bi)
+{
+    return ubrk_last(bi);
+}
+
 int textBreakNext(TextBreakIterator* bi)
 {
     return ubrk_next(bi);
 }
 
+int textBreakPrevious(TextBreakIterator* bi)
+{
+    return ubrk_previous(bi);
+}
+
 int textBreakPreceding(TextBreakIterator* bi, int pos)
 {
     return ubrk_preceding(bi, pos);
diff -Naur WebKit-r41128/WebCore/platform/text/TextEncoding.cpp WebKit-r41128-nx/WebCore/platform/text/TextEncoding.cpp
--- WebKit-r41128/WebCore/platform/text/TextEncoding.cpp	2009-01-21 00:14:22.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/text/TextEncoding.cpp	2009-02-23 16:01:27.268006710 -0500
@@ -36,6 +36,9 @@
 #include <unicode/unorm.h>
 #elif USE(QT4_UNICODE)
 #include <QString>
+#elif USE(GLIB_UNICODE)
+#include <glib.h>
+#include <wtf/GOwnPtr.h>
 #endif
 #include <wtf/HashSet.h>
 #include <wtf/OwnPtr.h>
@@ -114,6 +117,20 @@
     QString str(reinterpret_cast<const QChar*>(characters), length);
     str = str.normalized(QString::NormalizationForm_C);
     return newTextCodec(*this)->encode(reinterpret_cast<const UChar *>(str.utf16()), str.length(), handling);
+#elif USE(GLIB_UNICODE)
+    GOwnPtr<char> utf8source;
+    utf8source.set(g_utf16_to_utf8(characters, length, 0, 0, 0));
+
+    GOwnPtr<char> utf8normalized;
+    utf8normalized.set(g_utf8_normalize(utf8source.get(), -1, G_NORMALIZE_NFC));
+
+    long utf16length;
+    GOwnPtr<UChar> utf16normalized;
+    utf16normalized.set(g_utf8_to_utf16(utf8normalized.get(), -1, 0, &utf16length, 0));
+
+    CString result = newTextCodec(*this)->encode(utf16normalized.get(), utf16length, handling);
+
+    return result;
 #endif
 }
 
diff -Naur WebKit-r41128/WebCore/platform/text/TextEncodingRegistry.cpp WebKit-r41128-nx/WebCore/platform/text/TextEncodingRegistry.cpp
--- WebKit-r41128/WebCore/platform/text/TextEncodingRegistry.cpp	2009-01-21 00:14:22.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/text/TextEncodingRegistry.cpp	2009-02-23 16:01:27.293006590 -0500
@@ -47,6 +47,9 @@
 #if PLATFORM(QT)
 #include "qt/TextCodecQt.h"
 #endif
+#if PLATFORM(GTK)
+#include "gtk/TextCodecGtk.h"
+#endif
 
 using namespace WTF;
 
@@ -189,6 +192,11 @@
     TextCodecICU::registerBaseEncodingNames(addToTextEncodingNameMap);
     TextCodecICU::registerBaseCodecs(addToTextCodecMap);
 #endif
+
+#if USE(GLIB_UNICODE)
+    TextCodecGtk::registerBaseEncodingNames(addToTextEncodingNameMap);
+    TextCodecGtk::registerBaseCodecs(addToTextCodecMap);
+#endif
 }
 
 static void extendTextCodecMaps()
@@ -207,6 +215,11 @@
     TextCodecMac::registerEncodingNames(addToTextEncodingNameMap);
     TextCodecMac::registerCodecs(addToTextCodecMap);
 #endif
+
+#if USE(GLIB_UNICODE)
+    TextCodecGtk::registerExtendedEncodingNames(addToTextEncodingNameMap);
+    TextCodecGtk::registerExtendedCodecs(addToTextCodecMap);
+#endif
 }
 
 std::auto_ptr<TextCodec> newTextCodec(const TextEncoding& encoding)
diff -Naur WebKit-r41128/WebCore/rendering/SVGInlineTextBox.cpp WebKit-r41128-nx/WebCore/rendering/SVGInlineTextBox.cpp
--- WebKit-r41128/WebCore/rendering/SVGInlineTextBox.cpp	2009-02-15 03:48:53.000000000 -0500
+++ WebKit-r41128-nx/WebCore/rendering/SVGInlineTextBox.cpp	2009-02-23 16:01:27.321007310 -0500
@@ -484,7 +484,7 @@
     float thickness = SVGRenderStyle::cssPrimitiveToLength(object, object->style()->svgStyle()->strokeWidth(), 1.0f);
 
     const Font& font = object->style()->font();
-    thickness = max(thickness * powf(font.size(), 2.0f) / font.unitsPerEm(), 1.0f);
+    thickness = max(thickness * (float) pow(font.size(), 2.0f) / font.unitsPerEm(), 1.0f);
 
     if (decoration == UNDERLINE)
         y += thickness * 1.5f; // For compatibility with Batik/Opera
diff -Naur WebKit-r41128/WebCore/svg/SVGLength.cpp WebKit-r41128-nx/WebCore/svg/SVGLength.cpp
--- WebKit-r41128/WebCore/svg/SVGLength.cpp	2009-02-15 03:48:53.000000000 -0500
+++ WebKit-r41128-nx/WebCore/svg/SVGLength.cpp	2009-02-23 16:01:27.346280950 -0500
@@ -314,7 +314,7 @@
     else if (mode == LengthModeHeight)
         return value * height;
     else if (mode == LengthModeOther)
-        return value * sqrtf(powf(width, 2) + powf(height, 2)) / sqrtf(2.0f);
+        return value * sqrtf(pow(width, 2) + pow(height, 2)) / sqrtf(2.0f);
 
     return 0.0f;
 }
diff -Naur WebKit-r41128/WebKit/gtk/WebCoreSupport/ContextMenuClientGtk.cpp WebKit-r41128-nx/WebKit/gtk/WebCoreSupport/ContextMenuClientGtk.cpp
--- WebKit-r41128/WebKit/gtk/WebCoreSupport/ContextMenuClientGtk.cpp	2009-01-21 00:14:25.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/WebCoreSupport/ContextMenuClientGtk.cpp	2009-02-25 20:35:26.076003590 -0500
@@ -23,11 +23,13 @@
 #include "HitTestResult.h"
 #include "KURL.h"
 #include "NotImplemented.h"
+#include "CString.h"
 
 #include <glib-object.h>
 #include <glib/gi18n.h>
 #include <gtk/gtk.h>
 #include "webkitprivate.h"
+#include "webkitwebdownload.h"
 
 using namespace WebCore;
 
@@ -163,7 +165,18 @@
 
 void ContextMenuClient::downloadURL(const KURL& url)
 {
-    notImplemented();
+   WebKitWebDownload* download = webkit_web_download_new(url.string().utf8().data());
+
+   gboolean handled;
+   
+   g_signal_emit_by_name(m_webView, "download-created", download, &handled);
+   
+   if (handled)
+       webkit_web_download_start(download);
+   else {
+       webkit_web_download_cancel(download);
+       g_object_unref(download);
+   }
 }
 
 void ContextMenuClient::copyImageToClipboard(const HitTestResult&)
diff -Naur WebKit-r41128/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.cpp WebKit-r41128-nx/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.cpp
--- WebKit-r41128/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.cpp	2009-02-15 03:48:54.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.cpp	2009-02-23 16:01:27.369008390 -0500
@@ -21,6 +21,7 @@
 
 #include "config.h"
 #include "FrameLoaderClientGtk.h"
+#include "ResourceHandleClient.h"
 
 #include "Color.h"
 #include "DocumentLoader.h"
@@ -40,6 +41,8 @@
 #include "MouseEvent.h"
 #include "NotImplemented.h"
 #include "PlatformString.h"
+#include "ResourceHandle.h"
+#include "ResourceHandleInternal.h"
 #include "PluginDatabase.h"
 #include "RenderPart.h"
 #include "ResourceRequest.h"
@@ -264,6 +267,19 @@
     m_response = response;
 }
 
+bool FrameLoaderClient::dispatchDecidePolicyForNetworkRequest(const ResourceRequest& resourceRequest)
+{
+	WebKitWebView* page = getViewFromFrame(m_frame);
+	WebKitNetworkRequest* request = webkit_network_request_new(resourceRequest.url().string().utf8().data());
+	
+	gboolean isHandled = false;
+	g_signal_emit_by_name(page, "request-policy-decision-requested", m_frame, resourceRequest.url().string().utf8().data(), request, &isHandled);
+
+	g_object_unref(request);
+	
+	return !isHandled;
+}
+
 void FrameLoaderClient::dispatchDecidePolicyForMIMEType(FramePolicyFunction policyFunction, const String& mimeType, const ResourceRequest& resourceRequest)
 {
     ASSERT(policyFunction);
@@ -423,7 +439,7 @@
     String type = mimeType;
     // We don't use MIMETypeRegistry::getMIMETypeForPath() because it returns "application/octet-stream" upon failure
     if (type.isEmpty())
-        type = MIMETypeRegistry::getMIMETypeForExtension(url.path().substring(url.path().reverseFind('.') + 1));
+        type = MIMETypeRegistry::getMIMETypeForPath/*Extension*/(url.path().substring(url.path().reverseFind('.') + 1));
 
     if (type.isEmpty())
         return WebCore::ObjectContentFrame;
@@ -754,9 +770,23 @@
     g_signal_emit_by_name(m_frame, "load-done", false);
 }
 
-void FrameLoaderClient::download(ResourceHandle*, const ResourceRequest&, const ResourceRequest&, const ResourceResponse&)
+void FrameLoaderClient::download(ResourceHandle* handle, const ResourceRequest& request, const ResourceRequest& initialRequest, const ResourceResponse& response)
 {
-    notImplemented();
+    WebKitWebView* view = getViewFromFrame(m_frame);
+    // FIXME: Use initialRequest?
+    // FIXME: Don't create networkRequest from the URI but from the full object when the new API is merged.
+    WebKitNetworkRequest* networkRequest = webkit_network_request_new(request.url().string().utf8().data());
+    WebKitWebDownload* download = webkit_web_download_new_from_existing_connection(handle, networkRequest, response);
+    gboolean handled;
+    g_signal_emit_by_name(view, "download-created", download, &handled);
+
+    if (handled) {
+        webkit_web_download_start(download);
+    }
+    else {
+        handle->cancel();
+        g_object_unref(download);
+    }
 }
 
 ResourceError FrameLoaderClient::cancelledError(const ResourceRequest&)
diff -Naur WebKit-r41128/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.h WebKit-r41128-nx/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.h
--- WebKit-r41128/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.h	2009-02-15 03:48:54.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/WebCoreSupport/FrameLoaderClientGtk.h	2009-02-23 16:01:27.397006910 -0500
@@ -90,6 +90,7 @@
         virtual WebCore::Frame* dispatchCreatePage();
         virtual void dispatchShow();
 
+		virtual bool dispatchDecidePolicyForNetworkRequest(const WebCore::ResourceRequest&);
         virtual void dispatchDecidePolicyForMIMEType(WebCore::FramePolicyFunction, const WebCore::String& MIMEType, const WebCore::ResourceRequest&);
         virtual void dispatchDecidePolicyForNewWindowAction(WebCore::FramePolicyFunction, const WebCore::NavigationAction&, const WebCore::ResourceRequest&, WTF::PassRefPtr<WebCore::FormState>, const WebCore::String& frameName);
         virtual void dispatchDecidePolicyForNavigationAction(WebCore::FramePolicyFunction, const WebCore::NavigationAction&, const WebCore::ResourceRequest&, WTF::PassRefPtr<WebCore::FormState>);
diff -Naur WebKit-r41128/WebKit/gtk/webkit/webkitdefines.h WebKit-r41128-nx/WebKit/gtk/webkit/webkitdefines.h
--- WebKit-r41128/WebKit/gtk/webkit/webkitdefines.h	2009-01-21 00:14:25.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/webkit/webkitdefines.h	2009-02-23 16:01:27.421593470 -0500
@@ -68,6 +68,9 @@
 typedef struct _WebKitWebView WebKitWebView;
 typedef struct _WebKitWebViewClass WebKitWebViewClass;
 
+typedef struct _WebKitWebDownload WebKitWebDownload;
+typedef struct _WebKitWebDownloadClass WebKitWebDownloadClass;
+
 G_END_DECLS
 
 #endif
diff -Naur WebKit-r41128/WebKit/gtk/webkit/webkit.h WebKit-r41128-nx/WebKit/gtk/webkit/webkit.h
--- WebKit-r41128/WebKit/gtk/webkit/webkit.h	2009-01-21 00:14:25.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/webkit/webkit.h	2009-02-23 16:01:27.448004190 -0500
@@ -24,6 +24,7 @@
 #include <webkit/webkitversion.h>
 #include <webkit/webkitdefines.h>
 #include <webkit/webkitnetworkrequest.h>
+#include <webkit/webkitwebdownload.h>
 #include <webkit/webkitwebframe.h>
 #include <webkit/webkitwebsettings.h>
 #include <webkit/webkitwebinspector.h>
diff -Naur WebKit-r41128/WebKit/gtk/webkit/webkitprivate.h WebKit-r41128-nx/WebKit/gtk/webkit/webkitprivate.h
--- WebKit-r41128/WebKit/gtk/webkit/webkitprivate.h	2009-01-21 00:14:25.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/webkit/webkitprivate.h	2009-02-23 16:01:27.472007110 -0500
@@ -27,11 +27,14 @@
  * They are using WebCore which musn't be exposed to the outer world.
  */
 
+#include <curl/curl.h>
+
 #include <webkit/webkitdefines.h>
 #include <webkit/webkitwebview.h>
 #include <webkit/webkitwebframe.h>
 #include <webkit/webkitwebpolicydecision.h>
 #include <webkit/webkitwebnavigationaction.h>
+#include <webkit/webkitwebdownload.h>
 #include <webkit/webkitwebsettings.h>
 #include <webkit/webkitwebwindowfeatures.h>
 #include <webkit/webkitwebbackforwardlist.h>
@@ -44,9 +47,13 @@
 #include "InspectorClientGtk.h"
 #include "FrameLoaderClient.h"
 #include "WindowFeatures.h"
+#include "ResourceHandleClient.h"
+#include "ResourceResponse.h"
 
 #include <glib.h>
 
+class DownloadClient;
+
 namespace WebKit {
     WebKitWebView* getViewFromFrame(WebKitWebFrame*);
 
@@ -114,6 +121,20 @@
         gchar* uri;
     };
 
+    #define WEBKIT_WEB_DOWNLOAD_GET_PRIVATE(obj)    (G_TYPE_INSTANCE_GET_PRIVATE((obj), WEBKIT_TYPE_WEB_DOWNLOAD, WebKitWebDownloadPrivate))
+    typedef struct _WebKitWebDownloadPrivate WebKitWebDownloadPrivate;
+    struct _WebKitWebDownloadPrivate {
+        gchar* localUri;
+        gchar* suggestedFilename;
+        guint currentSize;
+        WebKitWebDownloadState state;
+        GIOChannel* outputChannel;
+        DownloadClient* downloadClient;
+        WebKitNetworkRequest* networkRequest;
+        WebCore::ResourceResponse* networkResponse;
+        RefPtr<WebCore::ResourceHandle> resourceHandle;
+    };
+
     PassRefPtr<WebCore::Frame>
     webkit_web_frame_init_with_web_view(WebKitWebView*, WebCore::HTMLFrameOwnerElement*);
 
@@ -144,6 +165,9 @@
     void
     webkit_web_policy_decision_cancel (WebKitWebPolicyDecision* decision);
 
+    WebKitWebDownload*
+    webkit_web_download_new_from_existing_connection(WebCore::ResourceHandle*, WebKitNetworkRequest*, const WebCore::ResourceResponse&);
+
     // FIXME: Move these to webkitwebframe.h once their API has been discussed.
 
     WEBKIT_API GSList*
